/*
 * Copyright 2007-2017 Charles du Jeu - Abstrium SAS <team (at) pyd.io>
 * This file is part of Pydio.
 *
 * Pydio is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * Pydio is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with Pydio.  If not, see <http://www.gnu.org/licenses/>.
 *
 * The latest code can be found at <https://pydio.com>.
 */

'use strict';

exports.__esModule = true;

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _model = require('./model');

var _model2 = _interopRequireDefault(_model);

var SelectionProvider = (function (_React$Component) {
    _inherits(SelectionProvider, _React$Component);

    function SelectionProvider() {
        _classCallCheck(this, SelectionProvider);

        _React$Component.apply(this, arguments);
    }

    SelectionProvider.prototype.componentDidMount = function componentDidMount() {
        var _this = this;

        var selection = this.props.selection;

        selection.then(function (_ref) {
            var selection = _ref.selection;
            var currentIndex = _ref.currentIndex;
            return _this.setState({ selection: new _model2['default'](selection, currentIndex) });
        });
    };

    SelectionProvider.prototype.render = function render() {
        return this.props.children(this.state || {});
    };

    _createClass(SelectionProvider, null, [{
        key: 'propTypes',
        get: function get() {
            return {
                selection: _react2['default'].PropTypes.instanceOf(Promise).isRequired,
                children: _react2['default'].PropTypes.func
            };
        }
    }]);

    return SelectionProvider;
})(_react2['default'].Component);

exports.SelectionProvider = SelectionProvider;
